#!/usr/bin/perl

use strict;
use warnings;

my $ref_F = shift;
my $sam = shift;
my %seq;
my %id_sam;

open(F,"$sam");
while(<F>)
{
	chomp;
	if($_ =~ /^@/)
	{
		next;
	}

	my @arr = split(/\t/);
	$id_sam{$arr[2]} = 0;
}
close(F);

my $id = "";
my $flag = 0;
open(F,"$ref_F");
while(<F>)
{
	chomp;
	if($_ =~ /^>(\S+)/)
	{
		my @arr = split(/\s/);
		$id = $1;
		if(exists $id_sam{$id})
		{
			$flag = 1;
		}
		else
		{
			$flag = 0;
		}
	}
	else
	{
		if($flag == 1)
		{
			$seq{$id} .= $_;
		}
	}
}
close(F);

foreach my $id (keys %seq)
{
	my $len = length($seq{$id});
	print "\@SQ\tSN:$id\tLN:$len\n";
}
system("cat $sam");
