#!/usr/bin/perl

use strict;
use warnings;
use Cwd 'abs_path';
use File::Basename;

my $Alignment = shift;
my $src_dir = shift;
my $ref_type = shift;
my $ref_dir = shift;
my $threads = shift;
my $ref_F = shift;
my $read_F = shift;
my $out_dir = shift;
my $threshold = shift;

if($ref_type eq "CDS")
{
	print " -$read_F\n";
	system("$Alignment mem -t $threads $ref_F $read_F > $out_dir/alignment.sam");
	open(W,">$out_dir/alignment.filtered.sam");
	open(F,"$out_dir/alignment.sam");
	while(my $f = <F>)
	{
		chomp($f);
		if($f =~ /^@/)
		{
			print W "$f\n";
			next;
		}
		my @arr = split(/\t/,$f);
		if($arr[4] >= $threshold)
		{
			print W "$f\n";
		}
	}
	close(F);
	close(W);
}
elsif($ref_type eq "Protein")
{
	print " -$read_F\n";
	system("$Alignment blastx -p $threads -d $ref_dir/fcmmdb -q $read_F -e $threshold -a $out_dir/alignment");
	system("$Alignment view -a $out_dir/alignment.daa -f sam -o $out_dir/alignment.sam");
	system("$src_dir/add_samHeader.pl $ref_F $out_dir/alignment.sam > $out_dir/alignment.filtered.sam");
}
