#!/usr/bin/perl

use strict;
use warnings;
use File::Basename;

my $AssignedProtein_F = shift;
my $out_dir = shift;

my %cds_len;
my %read_num;
my %cds_protein;
my %rpkm;
my %protein;
my $total_read_number = 0;
my $file_base = basename($AssignedProtein_F,".txt");
my $total_rpkm = 0;

print " -$AssignedProtein_F\n";

open(F,"$AssignedProtein_F");
while(<F>)
{
	chomp;
	my ($protein_id,$cds_length,$read_number,$go,$product) = split(/\t/);
	$cds_len{$protein_id} = $cds_length;
	$read_num{$protein_id} = $read_number;
	$protein{$protein_id} = $_;
	$total_read_number += $read_number;
}
close(F);


my $m = $total_read_number/1000000;
foreach my $protein_id (keys(%read_num))
{
	my $read_number = $read_num{$protein_id};
	my $cds_length = $cds_len{$protein_id};
	my $rpkm_v = $read_number/($cds_length/1000)/$m;
	
	$rpkm{$rpkm_v}{$protein_id} = 0;
	$total_rpkm += $rpkm_v;
}

open(W,">$out_dir/$file_base.rpkm.txt");
foreach my $rpkm_v (sort{$a <=> $b} keys %rpkm)
{
	foreach my $protein_id (sort{$a cmp $b} keys %{$rpkm{$rpkm_v}})
	{
		print W "$protein{$protein_id}\t$rpkm_v\n";
	}
}
close(W);

open(W,">$out_dir/total_rpkm.txt");
print W "$total_rpkm\n";
close(W);
