#!/usr/bin/perl

use strict;
use warnings;
use File::Basename;

my $m_out = shift;
my @functions = <$m_out/Functions/*.function.txt>;
my %hs_go;
my %hs_unique;
my %hs_common;
my %hs_stat;
my %hs_rpkm;
my %hs_function;

foreach my $function_F (@functions)
{
	print " - $function_F\n";
}

foreach my $function_F (@functions)
{
	my $base = basename($function_F,".function.txt");
	my $total_rpkm_F = "$m_out/Functions/$base.total_rpkm.txt";
	open(F, "$function_F");
	while(<F>)
	{
		chomp;
		my @arr = split(/\t/);
		$hs_go{$arr[0]}{$base} = 0;
		$hs_stat{$arr[0]}{$base} = "$arr[1]\t$arr[2]";
		$hs_rpkm{$arr[0]}{$base} = $arr[3];
		$hs_function{$arr[0]} = $arr[4];
	}
	close(F);
}

foreach my $go (sort{$a cmp $b} keys %hs_go)
{
	my $hs_spc = $hs_go{$go};
	my @k2 = keys %$hs_spc;
	my $no_k2 = $#k2;
	if($no_k2 == 0)
	{
		$hs_unique{$k2[0]}{$go} = 0;
	}

	if($no_k2 == $#functions)
	{
		$hs_common{$go} = 0;	
	}
}

open(W,">$m_out/sample_specific_functions.txt");
foreach my $sample (sort{$a cmp $b} keys %hs_unique)
{
	foreach my $go (sort{$a cmp $b} keys %{$hs_unique{$sample}})
	{
		print W "$sample\t$go\t$hs_stat{$go}{$sample}\t$hs_rpkm{$go}{$sample}\t$hs_function{$go}\n";
	}
}
close(W);

open(W,">$m_out/sample_common_functions.txt");
foreach my $go (sort{$a cmp $b} keys %hs_common)
{
	foreach my $sample (sort{$a cmp $b} keys %{$hs_rpkm{$go}})
	{
		print W "$go\t$sample\t$hs_stat{$go}{$sample}\t$hs_rpkm{$go}{$sample}\t$hs_function{$go}\n";
	}
}
close(W);
