#!/usr/bin/perl

use strict;
use warnings;

my $ref_type = shift;
my $annotation_F = shift;
my $alignment_F = shift;
my $out_dir = shift;
my %ann_protein;
my %ann_go;
my %ann_geneLen;
my %readNum;

print " - $alignment_F\n";
open(F,"$annotation_F");
while(<F>)
{
	chomp;
	my ($id,$pos,$str,$syn,$protein_id,$GO_id,$product) = split(/\t/);
	my ($pos_1,$pos_2) = split(/-/,$pos);
	my $geneLen = $pos_2-$pos_1+1;
	$ann_geneLen{$protein_id} = $geneLen;
	$ann_go{$protein_id} = "$GO_id\t$product";

	if($ref_type eq "CDS")
	{
		$ann_protein{$id}{$pos}{$str} = "$protein_id";
	}
}
close(F);

open(F,"$alignment_F");
while(<F>)
{
	chomp;
	if($_ =~ /^@/)
	{
		next;
	}

	my @arr = split(/\t/);

	if($ref_type eq "CDS")
	{	
    	my $pos;
    	my $pos_1;
    	my $pos_2;
    	my $str;
		
		my @arr2 = split(/\|/,$arr[2]);
	    my $id = $arr2[3];
	    if($arr[2] =~ /\|:(\d+)-(\d+)/)
	    {
	        $str = "+";
	        $pos_1 = $1;
	        $pos_2 = $2;
	    }
	    elsif($arr[2] =~ /\|:c(\d+)-(\d+)/)
	    {
	        $str = "-";
	        $pos_1 = $2;
	        $pos_2 = $1;
	    }
	
	    $pos = "$pos_1-$pos_2";
		if(!exists $ann_protein{$id}{$pos}{$str})
		{
			next;
		}

		my $protein_id = $ann_protein{$id}{$pos}{$str};
		if(exists $readNum{$protein_id})
		{
			$readNum{$protein_id}++;
		}
		else
		{
			$readNum{$protein_id} = 1;
		}
	}

	elsif($ref_type eq "Protein")
	{
		my @arr2 = split(/\|/,$arr[2]);
		my $protein_id = $arr2[3];

		if(!exists $ann_go{$protein_id})
		{
			next;
		}
		
		if(exists $readNum{$protein_id})
		{
			$readNum{$protein_id}++;
		}
		else
		{
			$readNum{$protein_id} = 1;
		}
	}
}
close(F);

open(W,">$out_dir/AssignedProtein.txt");
foreach my $protein_id (keys %readNum)
{
	print W "$protein_id\t$ann_geneLen{$protein_id}\t$readNum{$protein_id}\t$ann_go{$protein_id}\n";
}
close(W);
