#!/usr/bin/perl

use strict;
use warnings;
use File::Basename;

my $threads = shift;
my $TRIMMO = shift;
my $out_dir = shift;
my $read_1 = shift;
my $read_2 = shift;
my $state = "";
my $type = "";
my $base = "";
my $in_read  = "";
my $format = "";

if($read_1 =~ /\.gz$/){$state = "C";}
else{$state = "U";}

if(!$read_2){$type = "SE";}
else{$type = "PE";}

if($read_1 =~ /\.fa$/i || $read_1 =~ /\.fasta$/i)
{
	$format = "fa";
}
else
{
	$format = "fq";
}

if($format eq "fa")
{
	if($type eq "PE" && $state eq "C")
	{
		print "- merge: $read_1 \& $read_2\n";
		$base = basename($read_1,'_1.fasta.gz','_1.fa.gz');
		`zcat $read_1 $read_2 | gzip -c > $out_dir/$base.fa.gz`;
		$in_read = "$out_dir/$base.fa.gz";
	}
	elsif($type eq "PE" && $state eq "U")
	{
		print "- merge: $read_1 \& $read_2\n";
		$base = basename($read_1,'_1.fasta','_1.fa');
		`cat $read_1 $read_2 > $out_dir/$base.fa`;
		`gzip $out_dir/$base.fa`;
		$in_read = "$out_dir/$base.fa.gz";
	}
	elsif($type eq "SE")
	{
		$in_read = "$read_1";
	}
	print "Trimming reads is skiped.\n";
	
}
else
{
	if($type eq "PE" && $state eq "C")
	{
		print " - merge: $read_1 \& $read_2\n";
		`mkdir -p $out_dir/tmp_trimming`;
		$base = basename($read_1,'_1.fastq.gz','_1.fq.gz');
		`zcat $read_1 $read_2 | gzip -c > $out_dir/tmp_trimming/$base.fq.gz`;
		$in_read = "$out_dir/tmp_trimming/$base.fq.gz";
	}
	elsif($type eq "PE" && $state eq "U")
	{
		print " - merge: $read_1 \& $read_2\n";
		`mkdir -p $out_dir/tmp_trimming`;
		$base = basename($read_1,'_1.fastq','_1.fq');
		`cat $read_1 $read_2 > $out_dir/tmp_trimming/$base.fq`;
		`gzip $out_dir/tmp_trimming/$base.fq`;
		$in_read = "$out_dir/tmp_trimming/$base.fq.gz";
	}
	elsif($type eq "SE" && $state eq "C")
	{
		print " - $read_1\n";
		$base = basename($read_1,'.fastq.gz','.fq.gz');
		$in_read = "$read_1";
	}
	else
	{
		print " - $read_1\n";
		`mkdir -p $out_dir/tmp_trimming`;
		$base = basename($read_1,'.fastq.gz','.fq.gz');
		`cp $read_1 $out_dir/tmp_trimming/$base.fq`;
		`gzip $out_dir/tmp_trimming/$base.fq`;
		$in_read = "$out_dir/tmp_trimming/$base.fq.gz";
	}

	`java -jar $TRIMMO SE -threads $threads $in_read $out_dir/$base.trimmed.fq.gz LEADING:3 TRAILING:3 SLIDINGWINDOW:4:20 MINLEN:36`; 

	`rm -rf $out_dir/tmp_trimming/`;
}

open(W,">$out_dir/target_read.txt");
print W "$out_dir/$base.trimmed.fq.gz\n";
close(W);
